<template>
  <component class="ach-button"
             :is="htmlTag"
             :type="type"
             @click="$emit('click', $event)"
             :disabled="disabled"
             :class="[
              pattern && color && 'ach-button--pattern-' + pattern + '-' + color,
              disabled && 'ach-button--disabled',
              fullWidth && 'ach-button--full-width']"
  >
    <slot></slot>
    </component>
</template>

<script>

export default {
  name: 'CustomButton',
  props: {
    pattern: {
      type: String,
      default: 'primary',
      validator: value => value.match(/(primary)/)
    },
    color: {
      type: String,
      default: 'orange',
      validator: value => value.match(/(orange)/)
    },
    type: {
      type: String,
      default: 'submit',
      validator: value => value.match(/(button|reset|submit)/)
    },
    htmlTag: {
      type: String,
      default: 'button',
      validator: value => value.match(/(button|a)/)
    },
    disabled: {
      type: Boolean,
      default: false
    },
    fullWidth: {
      type: Boolean,
      default: false
    }
  }
}
</script>

<style lang="scss" scoped>
.ach-button {

  font-family: 'Inter', sans-serif;
  font-style: normal;
  font-weight: 600;
  font-size: 24px;
  line-height: 29px;

  padding: 15px 147px;

  background: #FFD700;
  border-radius: 5px;

  box-sizing: border-box;
  transition: 0.3s;

  border: none;

  cursor: pointer;
  outline: none;
  appearance: none;

  display: inline-flex;
  vertical-align: middle;
  text-align: center;
  justify-content: center;
  align-items: center;
}

.ach-button--full-width {
  width: 100%;
}

.ach-button--pattern-primary-orange {
  color: $x-color-full-black;
  background-color: $hsl-color-orange;

  &:hover {
    background-color: $hsl-color-orange-70
  }
}

</style>
